###################################################
### chunk number 1: init-prompt
###################################################
#line 74 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
options(prompt= "R> ", continue = "+  ")


###################################################
### chunk number 2: plot-visual-explanation
###################################################
#line 225 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
library("dtw")
data("aami3a")
ref <- window(aami3a,start=0,end=2)
test <- window(aami3a,start=2.7,end=5)
plot(dtw(test,ref,k=TRUE),type="two",off=1,match.lty=2,match.indices=20)


###################################################
### chunk number 3: dtw-simple-example
###################################################
#line 313 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
library("dtw")
data("aami3a")
ref <- window(aami3a,start=0,end=2)
test <- window(aami3a,start=2.7,end=5)
alignment <- dtw(test,ref)
alignment$distance


###################################################
### chunk number 4: dtw-normalized-distance
###################################################
#line 407 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
alignment <- dtw(test,ref,step.pattern=asymmetric)
alignment$distance


###################################################
### chunk number 5: symmetric2-step-pattern
###################################################
#line 423 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
symmetric2


###################################################
### chunk number 6: plot-symmetric1-step-pattern
###################################################
#line 490 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
plot(symmetric1)


###################################################
### chunk number 7: plot-symmetric2-step-pattern
###################################################
#line 495 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
plot(symmetric2)


###################################################
### chunk number 8: plot-asymmetric-step-pattern
###################################################
#line 500 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
plot(asymmetric)


###################################################
### chunk number 9: plot-rj4c-step-pattern
###################################################
#line 505 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
plot(rabinerJuangStepPattern(4,"c",TRUE))


###################################################
### chunk number 10: plot-sakoechiba-window
###################################################
#line 661 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
dtwWindow.plot(sakoeChibaWindow, window.size=2,reference=17, query=13)


###################################################
### chunk number 11: plot-open-begin-end-dtw
###################################################
#line 774 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"

idx<-seq(0,6.28,len=100)
query<-sin(idx)+runif(100)/10
reference<-cos(idx)

alignmentOBE <-
  dtw(query[44:88],reference,
      keep=TRUE,step=asymmetric,
      open.end=TRUE,open.begin=TRUE)
plot(alignmentOBE,type="two",off=1)



###################################################
### chunk number 12: dtw-multivariate-example
###################################################
#line 847 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
query <- cbind(1:10,1)
ref <- cbind(11:15,2)
dtw(query,ref,dist.method="Manhattan")$distance


###################################################
### chunk number 13: dtw-multivariate-example2
###################################################
#line 853 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
cxdist <- proxy::dist(query,ref,method="Manhattan")
dtw(cxdist)$distance


###################################################
### chunk number 14: rabiner-exercise-prepare
###################################################
#line 989 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
lm <- matrix(nrow = 6, ncol = 6, byrow = TRUE, c(
  1, 1, 2, 2, 3, 3, 
  1, 1, 1, 2, 2, 2, 
  3, 1, 2, 2, 3, 3, 
  3, 1, 2, 1, 1, 2, 
  3, 2, 1, 2, 1, 2, 
  3, 3, 3, 2, 1, 2
))


###################################################
### chunk number 15: rabiner-exercise-1
###################################################
#line 1018 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
alignment <- dtw(lm,step=asymmetric,keep=TRUE)
alignment$costMatrix
alignment$normalizedDistance


###################################################
### chunk number 16: rabiner-exercise-2
###################################################
#line 1032 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
alignmentOE <- dtw(lm,step=asymmetric,keep=TRUE,open.end=TRUE)
alignmentOE$jmin
alignmentOE$normalizedDistance


###################################################
### chunk number 17: costmatrix-figure-code-left eval=FALSE
###################################################
## #line 1058 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
## lcm <- alignment$localCostMatrix
## image(x=1:nrow(lcm),y=1:ncol(lcm),lcm)
## text(row(lcm),col(lcm),label=lcm)
## lines(alignment$index1,alignment$index2)


###################################################
### chunk number 18: costmatrix-figure-code-right eval=FALSE
###################################################
## #line 1064 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
## ccm <- alignment$costMatrix
## image(x=1:nrow(ccm),y=1:ncol(ccm),ccm)
## text(row(ccm),col(ccm),label=ccm)
## lines(alignment$index1,alignment$index2)


###################################################
### chunk number 19: costmatrix-figure-plot-left
###################################################
#line 1073 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
#line 1058 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw#from line#1073#"
lcm <- alignment$localCostMatrix
image(x=1:nrow(lcm),y=1:ncol(lcm),lcm)
text(row(lcm),col(lcm),label=lcm)
lines(alignment$index1,alignment$index2)
#line 1074 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"


###################################################
### chunk number 20: costmatrix-figure-plot-right
###################################################
#line 1076 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
#line 1064 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw#from line#1076#"
ccm <- alignment$costMatrix
image(x=1:nrow(ccm),y=1:ncol(ccm),ccm)
text(row(ccm),col(ccm),label=ccm)
lines(alignment$index1,alignment$index2)
#line 1077 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"


###################################################
### chunk number 21: two-way-plot-code
###################################################
#line 1126 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
#line 225 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw#from line#1126#"
library("dtw")
data("aami3a")
ref <- window(aami3a,start=0,end=2)
test <- window(aami3a,start=2.7,end=5)
plot(dtw(test,ref,k=TRUE),type="two",off=1,match.lty=2,match.indices=20)
#line 1127 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"


###################################################
### chunk number 22: three-way-plot
###################################################
#line 1156 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
## A noisy sine wave as query
## A cosine is for reference; sin and cos are offset by 25 samples
idx<-seq(0,6.28,len=100)
query<-sin(idx)+runif(100)/10
reference<-cos(idx)
dtw(query,reference,step=asymmetric,keep=TRUE)->alignment

## Beware of the reference's y axis, may be confusing
## Equivalent to plot(alignment,type="three")
#dtwPlotThreeWay(alignment)

## Highlight matches of chosen QUERY indices. We will do some index
## arithmetics to recover the corresponding indices along the warping
## curve
hq <- (0:8)/8
hq <- round(hq*100)      #  indices in query for  pi/4 .. 7/4 pi
hw <- (alignment$index1 %in% hq)   # where are they on the w. curve?
hi <- (1:length(alignment$index1))[hw]   # get the indices of TRUE elems
dtwPlotThreeWay(alignment,match.indices=hi)


###################################################
### chunk number 23: density-plot
###################################################
#line 1208 "d:/Rcompile/CRANpkg/local/2.12/dtw/inst/doc/dtw.Rnw"
dtw(query,reference,keep=TRUE,step=asymmetric)->alignment
dtwPlotDensity(alignment,normalize=TRUE)


